Index: XIOS/dev/branch_yushan/src/attribute_template_impl.hpp
===================================================================
--- XIOS/dev/branch_yushan/src/attribute_template_impl.hpp	(revision 1101)
+++ XIOS/dev/branch_yushan/src/attribute_template_impl.hpp	(revision 1102)
@@ -40,5 +40,5 @@
       {
          xios_map<StdString, CAttribute*>::iterator it;
-         printf("umap size = %lu, add = %p\n", umap.size(), &umap);
+         //printf("umap size = %lu, add = %p\n", umap.size(), &umap);
          it = umap.find(id);
          if(it == umap.end())
Index: XIOS/dev/branch_yushan/src/client.cpp
===================================================================
--- XIOS/dev/branch_yushan/src/client.cpp	(revision 1101)
+++ XIOS/dev/branch_yushan/src/client.cpp	(revision 1102)
@@ -176,6 +176,6 @@
       MPI_Comm_rank(contextComm,&tmp_rank) ;
       
-      #pragma omp critical (_output)
-      printf("Client %d : client.cpp Client::registerContext context add = %p\n", tmp_rank, &(*context));
+      // #pragma omp critical (_output)
+      // printf("Client %d : client.cpp Client::registerContext context add = %p\n", tmp_rank, &(*context));
       
       
@@ -225,6 +225,6 @@
         context->initClient(contextComm,contextInterComm) ;
         
-        #pragma omp critical (_output)
-        printf("Client %d : context->initClient(contextComm,contextInterComm) OK \n", getRank()) ;
+        // #pragma omp critical (_output)
+        // printf("Client %d : context->initClient(contextComm,contextInterComm) OK \n", getRank()) ;
         
         //contextInterComms->push_back(contextInterComm);
Index: XIOS/dev/branch_yushan/src/context_client.cpp
===================================================================
--- XIOS/dev/branch_yushan/src/context_client.cpp	(revision 1101)
+++ XIOS/dev/branch_yushan/src/context_client.cpp	(revision 1102)
@@ -73,5 +73,5 @@
         }
 
-        printf("clientRank = %d (%p)\n", clientRank, &clientRank);
+        // printf("clientRank = %d (%p)\n", clientRank, &clientRank);
       }
 
Index: XIOS/dev/branch_yushan/src/group_factory_impl.hpp
===================================================================
--- XIOS/dev/branch_yushan/src/group_factory_impl.hpp	(revision 1101)
+++ XIOS/dev/branch_yushan/src/group_factory_impl.hpp	(revision 1102)
@@ -70,13 +70,13 @@
       CObjectFactory::SetCurrentContextId
       (CGroupFactory::GetCurrentContextId());
-      printf("SetCurrentContextId OK %d , %d, %s\n", id.size(), CGroupFactory::HasChild(group, id), id);
+      //printf("SetCurrentContextId OK %d , %d, %s\n", id.size(), CGroupFactory::HasChild(group, id), id);
       if (id.size() == 0)
       {
          boost::shared_ptr<typename U::RelChild> value = CObjectFactory::CreateObject<typename U::RelChild>();
-         printf("boost::shared_ptr<typename U::RelChild> value OK\n");
+         //printf("boost::shared_ptr<typename U::RelChild> value OK\n");
          group->childList.insert(group->childList.end(), value.get());
-         printf("group->childList.insert OK\n");
+         //printf("group->childList.insert OK\n");
          group->childMap.insert(std::make_pair(value->getId(), value.get()));
-         printf("group->childMap.insert OK\n");
+         //printf("group->childMap.insert OK\n");
          return (value);
       }
@@ -89,9 +89,9 @@
       {
          boost::shared_ptr<typename U::RelChild> value = CObjectFactory::CreateObject<typename U::RelChild>(id);
-         printf("shared_ptr OK\n");
+         //printf("shared_ptr OK\n");
          group->childList.insert(group->childList.end(), value.get());
-         printf("childList.insert OK\n");
+         //printf("childList.insert OK\n");
          group->childMap.insert(std::make_pair(id, value.get()));
-         printf("childMap.insert OK\n");
+         //printf("childMap.insert OK\n");
          return (value);
       }
Index: XIOS/dev/branch_yushan/src/group_template_impl.hpp
===================================================================
--- XIOS/dev/branch_yushan/src/group_template_impl.hpp	(revision 1101)
+++ XIOS/dev/branch_yushan/src/group_template_impl.hpp	(revision 1102)
@@ -348,5 +348,5 @@
    U* CGroupTemplate<U, V, W>::createChild(const string& id) 
   {
-    printf("U* CGroupTemplate<U, V, W>::createChild(const string& id) %p\n", this->getShared());
+    //printf("U* CGroupTemplate<U, V, W>::createChild(const string& id) %p\n", this->getShared());
     return CGroupFactory::CreateChild<V>(this->getShared(), id).get() ;
   }
Index: XIOS/dev/branch_yushan/src/interface/c/icfield.cpp
===================================================================
--- XIOS/dev/branch_yushan/src/interface/c/icfield.cpp	(revision 1101)
+++ XIOS/dev/branch_yushan/src/interface/c/icfield.cpp	(revision 1102)
@@ -39,5 +39,5 @@
       CTimer::get("XIOS").resume() ;
       *_ret = CField::get(id);
-      printf("cxios_field_handle_create\n");
+      //printf("cxios_field_handle_create\n");
       CTimer::get("XIOS").suspend() ;
    }
@@ -49,5 +49,5 @@
       CTimer::get("XIOS").resume() ;
       *_ret = CFieldGroup::get(id);
-      printf("cxios_fieldgroup_handle_create\n");
+      //printf("cxios_fieldgroup_handle_create\n");
       CTimer::get("XIOS").suspend() ;
    }
Index: XIOS/dev/branch_yushan/src/node/context.cpp
===================================================================
--- XIOS/dev/branch_yushan/src/node/context.cpp	(revision 1101)
+++ XIOS/dev/branch_yushan/src/node/context.cpp	(revision 1102)
@@ -254,6 +254,6 @@
      MPI_Barrier(intraComm);
 
-     #pragma omp critical (_output)
-     printf("Client %d : context.cpp client = new CContextClient, client add = %p, clientRank = %d\n", tmp_rank, &(*client), client->clientRank) ;
+     // #pragma omp critical (_output)
+     // printf("Client %d : context.cpp client = new CContextClient, client add = %p, clientRank = %d\n", tmp_rank, &(*client), client->clientRank) ;
      
      #pragma omp critical
@@ -263,6 +263,6 @@
      registryIn->setPath(getId()) ;
      
-     #pragma omp critical (_output)
-     printf("Client %d : context.cpp registryIn->setPath, client add = %p, clientRank = %d\n", tmp_rank, &(*client), client->clientRank) ;
+     // #pragma omp critical (_output)
+     // printf("Client %d : context.cpp registryIn->setPath, client add = %p, clientRank = %d\n", tmp_rank, &(*client), client->clientRank) ;
 
      if (client->clientRank==0) registryIn->fromFile("xios_registry.bin") ;
Index: XIOS/dev/branch_yushan/src/object_factory_impl.hpp
===================================================================
--- XIOS/dev/branch_yushan/src/object_factory_impl.hpp	(revision 1101)
+++ XIOS/dev/branch_yushan/src/object_factory_impl.hpp	(revision 1102)
@@ -123,5 +123,5 @@
       if(U::AllMapObj  == NULL) U::AllMapObj  = new xios_map<StdString, xios_map<StdString, boost::shared_ptr<U> > >;
 
-      printf("so far so good : %d %d %d\n", CurrContext_ptr->empty(), CObjectFactory::HasObject<U>(id), id.empty());
+      //printf("so far so good : %d %d %d\n", CurrContext_ptr->empty(), CObjectFactory::HasObject<U>(id), id.empty());
       
       if (CurrContext_ptr->empty())
@@ -136,9 +136,9 @@
       {
          boost::shared_ptr<U> value(new U(id.empty() ? CObjectFactory::GenUId<U>() : id));
-         printf("in CreateObject, value OK\n");  
+         //printf("in CreateObject, value OK\n");  
          (* U::AllVectObj)[*CObjectFactory::CurrContext_ptr].insert((*U::AllVectObj)[*CObjectFactory::CurrContext_ptr].end(), value);
-         printf("AllVectObj insert OK\n");
+         //printf("AllVectObj insert OK\n");
          (* U::AllMapObj) [*CObjectFactory::CurrContext_ptr].insert(std::make_pair(value->getId(), value));
-         printf("AllMapObj insert OK\n");
+         //printf("AllMapObj insert OK\n");
 
          return value;
Index: XIOS/dev/branch_yushan/src/test/test_omp.f90
===================================================================
--- XIOS/dev/branch_yushan/src/test/test_omp.f90	(revision 1101)
+++ XIOS/dev/branch_yushan/src/test/test_omp.f90	(revision 1102)
@@ -100,12 +100,13 @@
     CALL xios_set_domain_attr("domain_A",lonvalue_2D=lon,latvalue_2D=lat)
     CALL xios_set_fieldgroup_attr("field_definition",enabled=.TRUE.)
-    print*, "test block OK", rank, size
+!     print*, "test block OK", rank, size
 
-!     CALL xios_get_handle("field_definition",fieldgroup_hdl) 
-!     print*, "test block II get_handle OK", rank, size
-!     CALL xios_add_child(fieldgroup_hdl,field_hdl,"field_B")
-!     print*, "test block II add_child OK", rank, size
-!     CALL xios_set_attr(field_hdl,field_ref="field_A",name="field_B")
-!     print*, "test block II set_attr OK", rank, size
+!   CALL xios_get_handle("field_definition",fieldgroup_hdl)
+!   CALL xios_add_child(fieldgroup_hdl,field_hdl,"field_B")
+!   CALL xios_set_attr(field_hdl,field_ref="field_A",name="field_B")
+
+!   CALL xios_get_handle("output",file_hdl)
+!   CALL xios_add_child(file_hdl,field_hdl)
+!   CALL xios_set_attr(field_hdl,field_ref="field_A",name="field_C")
 
     dtime%second = 3600
@@ -157,5 +158,5 @@
     print*, "xios_context_finalize OK", rank, size
 
-    !$omp master
+    !$omp master 
     !call MPI_Barrier(comm)
     CALL MPI_COMM_FREE(comm, ierr)
@@ -173,81 +174,4 @@
 
   !$omp end parallel
-
-
-  
-!   CALL xios_context_initialize("test",comm)
-
-!   CALL xios_get_handle("test",ctx_hdl)
-!   CALL xios_set_current_context(ctx_hdl)
-  
-  
-!   CALL xios_get_calendar_type(calendar_type)
-
-!   CALL xios_set_axis_attr("axis_A",n_glo=llm ,value=lval) ;
-!   CALL xios_set_domain_attr("domain_A",ni_glo=ni_glo, nj_glo=nj_glo, ibegin=ibegin, ni=ni,jbegin=jbegin,nj=nj,type='curvilinear')
-!   CALL xios_set_domain_attr("domain_A",data_dim=2, data_ibegin=-1, data_ni=ni+2, data_jbegin=-2, data_nj=nj+4)
-!   CALL xios_set_domain_attr("domain_A",lonvalue_2D=lon,latvalue_2D=lat)
-!   CALL xios_set_fieldgroup_attr("field_definition",enabled=.TRUE.)
-
-!   CALL xios_get_handle("field_definition",fieldgroup_hdl)
-!   CALL xios_add_child(fieldgroup_hdl,field_hdl,"field_B")
-!   CALL xios_set_attr(field_hdl,field_ref="field_A",name="field_B")
-
-!   CALL xios_get_handle("output",file_hdl)
-!   CALL xios_add_child(file_hdl,field_hdl)
-!   CALL xios_set_attr(field_hdl,field_ref="field_A_zoom",name="field_C")
-  
-!   dtime%second = 3600
-!   CALL xios_set_timestep(dtime)
-
-!   ! The calendar is created as soon as the calendar type is defined. This way
-!   ! calendar operations can be used before the context definition is closed
-!   CALL xios_get_time_origin(date)
-!   PRINT *, "--> year length = ", xios_get_year_length_in_seconds(date%year)
-!   PRINT *, "--> day length = ", xios_get_day_length_in_seconds()
-!   CALL xios_date_convert_to_string(date, date_str)
-!   PRINT *, "time_origin = ", date_str
-!   PRINT *, "xios_date_get_second_of_year(time_origin) = ", xios_date_get_second_of_year(date)
-!   PRINT *, "xios_date_get_day_of_year(time_origin) = ", xios_date_get_day_of_year(date)
-!   PRINT *, "xios_date_get_fraction_of_year(time_origin) = ", xios_date_get_fraction_of_year(date)
-!   PRINT *, "xios_date_get_second_of_day(time_origin) = ", xios_date_get_second_of_day(date)
-!   PRINT *, "xios_date_get_fraction_of_day(time_origin) = ", xios_date_get_fraction_of_day(date)
-!   dtime%timestep = 1
-!   dtime = 0.5 * dtime
-!   CALL xios_duration_convert_to_string(dtime, dtime_str)
-!   PRINT *, "duration = ", dtime_str
-!   date = date + 3 * (dtime + dtime)
-!   CALL xios_date_convert_to_string(date, date_str)
-!   PRINT *, "date = time_origin + 3 * (duration + duration) = ", date_str
-!   PRINT *, "xios_date_convert_to_seconds(date) = ", xios_date_convert_to_seconds(date)
-!   PRINT *, "xios_date_convert_to_seconds(date - 2.5h) = ", xios_date_convert_to_seconds(date - 2.5 * xios_hour)
-
-!   ni=0 ; lonvalue(:,:)=0;
-!   CALL xios_get_domain_attr("domain_A",ni=ni,lonvalue_2D=lonvalue)
-!   print *,"ni",ni
-!   !print *,"lonvalue",lonvalue;
-
-!   CALL xios_is_defined_field_attr("field_A",enabled=ok)
-!   PRINT *,"field_A : attribute enabled is defined ? ",ok
-  
-!   CALL xios_close_context_definition()
-!   print*, "xios_close_context_definition OK"  
-
-!   PRINT*,"field field_A is active ? ",xios_field_is_active("field_A")
-
-
-!   call MPI_Barrier(comm, ierr)
-
-!   !DO ts=1,24*10
-!   DO ts=1,6
-!     CALL xios_update_calendar(ts)
-!     CALL xios_send_field("field_A",field_A)
-!     CALL wait_us(5000)
-!   ENDDO
-  
-
-!   CALL xios_context_finalize()
-
-!   DEALLOCATE(lon, lat, field_A, lonvalue)
 
 